/*
 * Nde - a lightweight, Qt based, desktop toolset
 * Copyright (C) 2016  Luís Pereira <luis.artur.pereira@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301  USA
 */

#ifndef NDEPANELAPPLICATION_P_H
#define NDEPANELAPPLICATION_P_H

#include "ndepanelapplication.h"

namespace Nde {
class Settings;
}

class NdePanelApplicationPrivate {
    Q_DECLARE_PUBLIC(NdePanelApplication)
public:

    NdePanelApplicationPrivate(NdePanelApplication *q);
    ~NdePanelApplicationPrivate() {};

    Nde::Settings *mSettings;

    INdePanel::Position computeNewPanelPosition(const NdePanel *p, const int screenNum);

private:
    NdePanelApplication *const q_ptr;
};

#endif // NDEPANELAPPLICATION_P_H
