/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)LGPL2+
 *
 * Nde - a lightweight, Qt based, desktop toolset
 * https://lxqt.org
 *
 * Copyright: 2013 Razor team
 * Authors:
 *   Alexander Sokoloff <sokoloff.a@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#include "ndecpuloadplugin.h"
#include "ndecpuload.h"
#include "ndecpuloadconfiguration.h"

#include <QVBoxLayout>

NdeCpuLoadPlugin::NdeCpuLoadPlugin(const INdePanelPluginStartupInfo &startupInfo):
    QObject(),
    INdePanelPlugin(startupInfo)
{
    mWidget = new QWidget();
    mContent = new NdeCpuLoad(this, mWidget);
    QVBoxLayout *layout = new QVBoxLayout(mWidget);
    layout->setContentsMargins(0, 0, 0, 0);
    layout->setSpacing(0);
    layout->addWidget(mContent);
    layout->setStretchFactor(mContent, 1);
}

NdeCpuLoadPlugin::~NdeCpuLoadPlugin()
{
    delete mWidget;
}

QWidget *NdeCpuLoadPlugin::widget()
{
    return mWidget;
}

QDialog *NdeCpuLoadPlugin::configureDialog()
{
    return new NdeCpuLoadConfiguration(settings());
}

void NdeCpuLoadPlugin::settingsChanged()
{
    mContent->settingsChanged();
}
