#include "adddesktop.h"
#include "ui_adddesktop.h"
#include <QPainter>
#include <QStyleOption>

AddDesktop::AddDesktop(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::AddDesktop)
{
    ui->setupUi(this);
}

AddDesktop::~AddDesktop()
{
    delete ui;
}

void AddDesktop::mousePressEvent(QMouseEvent *event){
    click = true;
    setProperty("Click",true);
    style()->polish(this);
    style()->polish(ui->pushButton);
    style()->polish(ui->label);
    update();
}

void AddDesktop::mouseReleaseEvent(QMouseEvent *event){
    click = false;
    setProperty("Click",false);
    style()->polish(this);
    style()->polish(ui->pushButton);
    style()->polish(ui->label);
    Q_EMIT PluClick();
}

void AddDesktop::enterEvent(QEvent *){
    hover = true;
    setProperty("Hover",true);
    style()->polish(this);
    style()->polish(ui->pushButton);
    style()->polish(ui->label);
    update();
}
void AddDesktop::leaveEvent(QEvent *){
    hover = false;
    setProperty("Hover",false);
    style()->polish(this);
    style()->polish(ui->pushButton);
    style()->polish(ui->label);
    update();
}

void AddDesktop::cancleSelect(){
    setProperty("Hover",false);
    style()->polish(this);
    style()->polish(ui->pushButton);
    style()->polish(ui->label);
    update();
}

void AddDesktop::Select(){
    Q_EMIT PluClick();
}

void AddDesktop::setSelect(){
    setProperty("Hover",true);
    style()->polish(this);
    style()->polish(ui->pushButton);
    style()->polish(ui->label);
    update();
}

void AddDesktop::paintEvent(QPaintEvent *event)
{
    QPainter p(this);
    QStyleOption opt;
    opt.initFrom(this);
    style()->drawPrimitive(QStyle::PE_Widget, &opt, &p, this);
}

void AddDesktop::on_pushButton_clicked()
{
    Q_EMIT PluClick();
}
