#ifndef DESKTOPSCREEN_H
#define DESKTOPSCREEN_H

#include <QWidget>

#define TEXT_HEIGHT 30
#define SPACE_BETWEEN 10
#define PEN_FRAME 2
#define MAX_LENGTH 400
#define MAX_WIDTH 600
#define ICON_LENGTH 80
#define ICON_WIDTH 100
#define DESKTOPSIZE QSize(180,130)
#define PREVIEWSIZE QSize(172,108)

namespace Ui {
class DesktopScreen;
}

class DesktopScreen : public QWidget
{
    Q_OBJECT

public:
    explicit DesktopScreen(QWidget *parent = nullptr,int id = 0);
    ~DesktopScreen();

    void setPixmap(const QPixmap pixmap);
    void setText(const QString text);
    void initwindowspic();
    void setselected();
    void cancleseelect();
    void hideCloseBtn();
    bool isSelected(){
        return m_selected;
    }
    int getDesktopid(){
        return m_desktop;
    }

Q_SIGNALS:
    void desktopChanged(int id);
    void desktopselectd(int id);
    void desktopdelete(int id);

private Q_SLOTS:
    void backgroundadd(WId);
    void backgrounddel(WId);
    void removedesktop() { Q_EMIT desktopdelete(m_desktop);}

    void on_pushButton_clicked();

protected:
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void dragEnterEvent(QDragEnterEvent  * e);
    virtual void dropEvent(QDropEvent  * e);
    virtual void enterEvent(QEvent *);
    virtual void leaveEvent(QEvent *);
    virtual void mouseDoubleClickEvent(QMouseEvent *event);
    void paintEvent(QPaintEvent *event);

private:
    QRect getPixmapRect();
    QRect getTextRect();
    QRect getpicRect();
    void selectChanged(){
        m_selected = false;
//        repaint();
    }
    void updatebackground();

private:
    Ui::DesktopScreen *ui;
    bool m_selected;        //是否选中
    QString m_title;         //图片名称
    bool m_titleVisible;     //名称可见
    QPixmap m_pixmap;       //图片
    QSize desktopsize;
    int m_desktop;

    QHash<WId,QPixmap> m_piclist;
    bool shadow {true};
    int startx ,starty;
};

#endif // DESKTOPSCREEN_H
