#ifndef DESKTOPWIDGET_H
#define DESKTOPWIDGET_H

#include <QWidget>
#include <nde/Nde/Settings>
#include "desktopswitchbutton.h"
#include "desktopitem.h"
#include "../panel/indepanelplugin.h"
#include "desktopscreen.h"
#include "windowscreen.h"
#include "adddesktop.h"

QT_BEGIN_NAMESPACE
namespace Ui { class desktopWidget; }
QT_END_NAMESPACE



class desktopWidget : public QWidget
{
    Q_OBJECT

public:
    desktopWidget(INdePanelPlugin * plugin, QWidget *parent = nullptr);
    void setbackground();
    void setdesktopitem();

    ~desktopWidget();

    void realign();
protected:
    virtual bool event(QEvent *event);
    virtual void resizeEvent(QResizeEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void paintEvent(QPaintEvent *event);
private Q_SLOTS:
    void selectwindows(WId id);
    void drawwindow(int cur_desktop);
    void selectdesktop(int id);
    void drawdesktop(bool init = false);
    void Refresh();
    void adddesktop();
    void resizeScreen(int);

private:
    void Init();
    void clearLayout(QBoxLayout*);
    void InitSize();
    void addShadowEffect(QWidget*);
    void getWindowsize();
    void setWindowsize();

    void selectDesktop(int direction);
    void selectWindowupdown(int direction);
    void selectWindowleftright(int direction);
    void enterWindow();
    void InitFirstWindow();

private:
    INdePanelPlugin * mPlugin;
    bool flag {true};
    Ui::desktopWidget *ui;
    QVBoxLayout * windowlayout;
    QVBoxLayout * deskLayout;
//    QScrollArea* m_pChatListScrollArea {nullptr};
    QScrollBar * m_scroolbar{nullptr};
    QScrollBar * m_hscroolbar{nullptr};
    int m_maxbar;
    int m_maxhbar;
    AddDesktop * plubtn;

    int oldwidth{0};
    int oldheight{0};

    QHash<WId,bool> windowflaglist;

    typedef QVector<WindowScreen*> twindowlist;
    QMap<int,twindowlist> ptr_windowlist;
    QVector<QWidget*> ptr_desktoplist;
    DesktopScreen * cur_desktop {nullptr};
    AddDesktop * cur_plubutton{nullptr};


    bool mCompositorOpen; //特效开关
};
#endif // DESKTOPWIDGET_H
