#ifndef WINDOWSCREEN_H
#define WINDOWSCREEN_H

#include <QWidget>
#include <QStyle>
#include <QDebug>
#include <QApplication>

#define WIN_SCREEN_FIX_HEIGHT       300

namespace Ui {
class WindowScreen;
}

class WindowScreen : public QWidget
{
    Q_OBJECT

public:
    explicit WindowScreen(WId wid,int d_id,QWidget *parent = nullptr);
    ~WindowScreen();

    void setpixmap(QPixmap pic,WId Wid,QString str);
    void selectChanged();

    void selectWindow();
    bool isselect(){
        return m_select;
    }
    WId getWindwonid(){
        return m_wid;
    }
Q_SIGNALS:
    void activewindow(WId id);
    void deletewindow(WId id);
    void Refresh(int id);
private Q_SLOTS:
    void removewindow() { Q_EMIT deletewindow(m_wid);}
    void on_pushButton_clicked();

protected:
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseMoveEvent(QMouseEvent *e);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void enterEvent(QEvent *);
    virtual void leaveEvent(QEvent *);
    void paintEvent(QPaintEvent *event);
private:
    Ui::WindowScreen *ui;
    QPoint pos;
    QPixmap m_map;
    QSize m_size;
    WId m_wid;
    int desktopid;
    QString m_title;
    bool m_select;

    int mMaxWidth;
    int mMinWidth;
    int mCloseBtnLen;
    int mTextHeight;
    int mHeight;
};

#endif // WINDOWSCREEN_H
