#include "mainmenucategoryitem.h"
#include "pinyinhandle.h"
#include <QDropEvent>
#include <QMimeData>
#include "appmanager.h"
#include <QDebug>

MainMenuCategoryItem::MainMenuCategoryItem(QString category, QWidget *parent):
    QWidget(parent)
{
    this->setObjectName("MainMenuCategoryItem");

    mCategoryTitleWidget = new QWidget(this);
    mCategoryTitleWidget->setFixedHeight(34);
    mCategoryTitleWidget->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);

    mLabel = new QLabel(mCategoryTitleWidget);
    mLabel->setFixedHeight(29);
    mLabel->setText(category);
    mLabel->setWordWrap(false);
    mLabel->setTextFormat(Qt::PlainText);
    mLabel->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);

    mLine = new QFrame(mCategoryTitleWidget);
    mLine->setObjectName("line");
    mLine->setFixedHeight(1);
    mLine->setFrameShape(QFrame::HLine);

    mMainlayout = new QVBoxLayout();
    mMainlayout->setMargin(0);
    mMainlayout->setSpacing(2);
    mMainlayout->setContentsMargins(0,10,0,0);
    mMainlayout->addWidget(mLabel);
    mMainlayout->addWidget(mLine);

    this->setMinimumSize(100,44);
    this->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Preferred);
    this->setLayout(mMainlayout);

    //开启接收托放事件
//    if(common)
//    {
//        this->setAcceptDrops(true);
//    }
}

void MainMenuCategoryItem::addItem(MainMenuApplicationItem *item)
{
    m_items.append(item);
}

void MainMenuCategoryItem::removeItem(MainMenuApplicationItem *item)
{
    m_items.removeAll(item);
}

QList<MainMenuApplicationItem *> MainMenuCategoryItem::getItems()
{
    return m_items;
}

void MainMenuCategoryItem::setFilter(QString filter)
{
    bool show = false;

    QList<MainMenuApplicationItem*>::iterator it = m_items.begin();
    while(it != m_items.end())
    {
        if(PinyinHandle::checkSearchFit((*it)->desktopFile(), filter))
        {
            (*it)->show();
            show = true;
        }
        else
        {
            (*it)->hide();
        }
        it++;
    }
    this->setVisible(show);
}

//void MainMenuCategoryItem::dragEnterEvent(QDragEnterEvent *event)
//{
//    if(mCommon)
//    {
//        const QMimeData* mimeData = event->mimeData();
//        if(mimeData->hasUrls()
//           && (event->dropAction() == Qt::CopyAction
//               || event->dropAction() == Qt::LinkAction)) {
//            event->acceptProposedAction();
//        }
//    }
//}

//void MainMenuCategoryItem::dropEvent(QDropEvent *event)
//{
//    const QMimeData* mimeData = event->mimeData();
//    if(mCommon)
//    {
//        if(mimeData->hasUrls()
//           && (event->dropAction() == Qt::CopyAction
//               || event->dropAction() == Qt::LinkAction)) {
//            const QList<QUrl> urlList = mimeData->urls();
//            for(const QUrl& url : urlList) {
//                QString name = url.fileName();
//                XdgDesktopFile df;
//                df.load(name);
//                if(df.isValid() ){
//                }
//            }
//        }
//    }
//}
