#ifndef MAINMENUCATEGORYITEM_H
#define MAINMENUCATEGORYITEM_H

#include <QWidget>
#include <QLabel>
#include <QBoxLayout>
#include <QFrame>
#include "mainmenuapplicationitem.h"

class MainMenuCategoryItem : public QWidget
{
    Q_OBJECT
    Q_PROPERTY(QString categoryName READ categoryName WRITE setCategoryName)

public:
    explicit MainMenuCategoryItem(QString category, QWidget *parent = nullptr);

    QString categoryName() {return mLabel->text();}
    void setCategoryName(const QString name) {mLabel->setText(name);}

    void addItem(MainMenuApplicationItem* item);
    void removeItem(MainMenuApplicationItem* item);
    QList<MainMenuApplicationItem*> getItems();

    void setFilter(QString filter);

protected :
//    virtual void dragEnterEvent(QDragEnterEvent *event) override;
//    virtual void dropEvent(QDropEvent *event) override;

private:
    QLabel * mLabel;
    QFrame * mLine;
    QWidget * mCategoryTitleWidget;
    QVBoxLayout * mMainlayout;

    QList<MainMenuApplicationItem*> m_items; //
};

#endif // MAINMENUCATEGORYITEM_H
