#include "mainmenucategoryitemfull.h"
#include "pinyinhandle.h"
#include <QDebug>

MainMenuCategoryItemFull::MainMenuCategoryItemFull(QString category, QWidget *parent) :
    QWidget(parent)
{
    this->setObjectName("MainMenuCategoryItemFull");

    mCategaryBtn = 0;

    mLabel = new QLabel(this);
    mLabel->setFixedHeight(30);
    mLabel->setText(category);
    mLabel->setWordWrap(false);
    QFont font = mLabel->font();
    font.setPixelSize(16);
    mLabel->setTextFormat(Qt::PlainText);
    mLabel->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
    mLabel->setAlignment(Qt::AlignCenter);

    mLine = new QFrame(this);
    mLine->setObjectName("line");
    mLine->setFixedHeight(1);
    mLine->setFrameShape(QFrame::HLine);
    mLine->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);

    mMainLayout = new QHBoxLayout();
    mMainLayout->setMargin(0);
    mMainLayout->setSpacing(20);
    mMainLayout->setContentsMargins(0,10,0,10);
    mMainLayout->addWidget(mLabel);
    mMainLayout->addWidget(mLine);
    mMainLayout->setAlignment(mLabel, Qt::AlignVCenter);
    mMainLayout->setAlignment(mLine, Qt::AlignVCenter);

    this->setFixedHeight(51);
    this->setMinimumWidth(100);
    this->setSizePolicy(QSizePolicy::Preferred, QSizePolicy::Fixed);
    this->setLayout(mMainLayout);
}

void MainMenuCategoryItemFull::addItem(MainMenuApplicationItemFull *item)
{
    m_items.append(item);
}

void MainMenuCategoryItemFull::removeItem(MainMenuApplicationItemFull *item)
{
    m_items.removeAll(item);
}

QList<MainMenuApplicationItemFull *> MainMenuCategoryItemFull::getItems()
{
    return m_items;
}

void MainMenuCategoryItemFull::setFilter(QString filter)
{
    bool show = false;

    QList<MainMenuApplicationItemFull*>::iterator it = m_items.begin();
    while(it != m_items.end())
    {
        if(PinyinHandle::checkSearchFit((*it)->desktopFile(), filter))
        {
            (*it)->show();
            show = true;
        }
        else
        {
            (*it)->hide();
        }
        it++;
    }
    this->setVisible(show);
    if(mCategaryBtn) mCategaryBtn->setVisible(show);
}

void MainMenuCategoryItemFull::setCategaryBtn(QToolButton *btn)
{
    mCategaryBtn = btn;
}

QToolButton *MainMenuCategoryItemFull::getCategaryBtn()
{
    return mCategaryBtn;
}
