#ifndef MAINMENUCATEGORYITEMFULL_H
#define MAINMENUCATEGORYITEMFULL_H

#include <QWidget>
#include <QLabel>
#include <QBoxLayout>
#include <QFrame>
#include "mainmenuapplicationitemfull.h"

class MainMenuCategoryItemFull : public QWidget
{
    Q_OBJECT
    Q_PROPERTY(QString categoryName READ categoryName WRITE setCategoryName)

public:
    explicit MainMenuCategoryItemFull(QString category, QWidget *parent = nullptr);

    QString categoryName() {return mLabel->text();}
    void setCategoryName(const QString name) {mLabel->setText(name);}

    void addItem(MainMenuApplicationItemFull* item);
    void removeItem(MainMenuApplicationItemFull* item);
    QList<MainMenuApplicationItemFull*> getItems();

    void setFilter(QString filter);

    //用于设置右侧分类的快速导航按钮
    void setCategaryBtn(QToolButton * btn);
    QToolButton* getCategaryBtn();

private:
    QLabel * mLabel;
    QFrame * mLine;
    QHBoxLayout * mMainLayout;

    QToolButton * mCategaryBtn;

    QList<MainMenuApplicationItemFull*> m_items; //
};

#endif // MAINMENUCATEGORYITEMFULL_H
