#ifndef PINYINHANDLE_H
#define PINYINHANDLE_H

#include <QObject>
#include <XdgDesktopFile>

class PinyinHandle : public QObject
{
    Q_OBJECT
public:
    explicit PinyinHandle(QObject *parent = nullptr);

    //汉字转拼音
    static QString ConvertToPinyin(const QString zhStr);
    //汉字转全拼
    static QString ConvertToQuanpin(const QString zhStr);

    //判断字符是否为中文
    static bool isZh(const QChar zh);

    //字符串处理
    static QString removeAllSpace(QString str);

    static QString escape(QString string);

    //
    static bool checkSearchFit(const XdgDesktopFile deskFile, const QString &filter);
};

#endif // PINYINHANDLE_H
