#ifndef POWERMENU_H
#define POWERMENU_H

#include <QVBoxLayout>
#include <QPropertyAnimation>
#include <QParallelAnimationGroup>
#include <QProcess>
#include "toolbutton.h"
#include <Power>

class PowerMenu : public QWidget
{
    Q_OBJECT
public:
    explicit PowerMenu(QWidget *parent = nullptr);

    void expend(bool extend);

    QList<ToolButton*> getBtns();

    void restorePowerMenu();

Q_SIGNALS:
    void signalAnimFinished();
private Q_SLOTS:
    void onAnimFinished();
    void onComputerSleep();
    void onComputerSwitch();
    void onComputerLogout();
    void onComputerReboot();
    void onComputerPowerOff();

private:
    bool checkVirtualMachine();//判断虚拟机
    bool checkZteVersion(); //判断是否是zte定制版本

private:
    Nde::Power * m_power;
    bool mExtend;
    QVBoxLayout * mLayout;
    ToolButton* mBtnSleep;
    ToolButton* mBtnSwitch;
    ToolButton* mBtnLogout;
    ToolButton* mBtnReboot;
    ToolButton* mBtnPowerOff;
//    QList<ToolButton*> mBtnList;
    QHash<ToolButton*, QPropertyAnimation*> mBtnAnims;
    QParallelAnimationGroup * mAnimGroup;
};

#endif // POWERMENU_H
