#ifndef NOTIFYDISPLAYWIDGET_H
#define NOTIFYDISPLAYWIDGET_H

#include <QWidget>
#include <Nde/Settings>
#include "notifygroup.h"
#include "../panel/indepanelplugin.h"

namespace Ui {
class NotifyDisplayWidget;
}

class NotifyDisplayWidget : public QWidget
{
    Q_OBJECT

public:
    explicit NotifyDisplayWidget(INdePanelPlugin *plugin,QWidget *parent = nullptr);
    ~NotifyDisplayWidget();

    void realign();

Q_SIGNALS:
    //通知中心失去焦点关闭窗口
    void lostFocus();
    //在通知中心用户点击关闭
    void notifyClosed(uint id, uint reason);
    //用户点击动作发出信号
    void actionTriggered(uint id, const QString &actionKey);

    void actionNewNotify();

public Q_SLOTS:
    //应用产生通知消息
    void onAddNotify(NotifyMessage nm);
    //应用主动关闭通知消息
    void onRmoveNotify(uint id, uint reason);

protected:
    bool event(QEvent *event) override;
    virtual void resizeEvent(QResizeEvent *event) override;

private Q_SLOTS:
    void onGroupClose();
    void onClear();
    //功能按钮
    void onSetting();
    void onRemote();
    void onScreenShot();
    void onMultiScreen();

private:
    Ui::NotifyDisplayWidget *m_ui;
    QVBoxLayout * m_notifyLayout;
    INdePanelPlugin * mPlugin;

    bool mCompositorOpen; //特效开关

    QHash<uint, NotifyGroup*> m_groups;
};

#endif // NOTIFYDISPLAYWIDGET_H
