#ifndef NOTIFYGROUPTITLE_H
#define NOTIFYGROUPTITLE_H

#include <QWidget>
#include "notifymessage.h"

namespace Ui {
class NotifyGroupTitle;
}

class NotifyGroupTitle : public QWidget
{
    Q_OBJECT

public:
    explicit NotifyGroupTitle(int width, NotifyMessage nm, QWidget *parent = nullptr);
    ~NotifyGroupTitle();

    void setNotifyCount(int count);

Q_SIGNALS:
    void signalGroupClose();
    void signalGroupExtend(bool extend);

protected:
    virtual void paintEvent(QPaintEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void mouseReleaseEvent(QMouseEvent *event);
    virtual void enterEvent(QEvent *event);
    virtual void leaveEvent(QEvent *event);

private:
    Ui::NotifyGroupTitle *ui;
    uint m_appID;
    bool m_extend;
};

#endif // NOTIFYGROUPTITLE_H

