#ifndef NOTIFYMESSAGE_H
#define NOTIFYMESSAGE_H

#include <QPixmap>
#include <QStringList>
#include <QVariantMap>

#define NOTIFY_ICON_SIZE QSize(32, 32)

class NotifyMessage
{
public:
    uint m_id;
    QString m_name;
    QString m_summary;
    QString m_body;
    QPixmap m_icon;
    QPixmap m_pixmap;
    QList<QPair<QString, QString>> m_actions;
    int m_timeout;
    bool m_noSave;

    NotifyMessage()
    {
        m_id = 0;
        m_timeout = 0;
        m_noSave = false;
    }

    NotifyMessage(const NotifyMessage &nm)
    {
        m_id = nm.m_id;
        m_name = nm.m_name;
        m_summary = nm.m_summary;
        m_body = nm.m_body;
        m_icon = nm.m_icon;
        m_pixmap = nm.m_pixmap;
        m_actions = nm.m_actions;
        m_timeout = nm.m_timeout;
        m_noSave = nm.m_noSave;
        m_origin_actions = nm.m_origin_actions;
        m_origin_hints = nm.m_origin_hints;
        m_origin_icon = nm.m_origin_icon;
    }

    void operator=(const NotifyMessage &nm)
    {
        m_id = nm.m_id;
        m_name = nm.m_name;
        m_summary = nm.m_summary;
        m_body = nm.m_body;
        m_icon = nm.m_icon;
        m_pixmap = nm.m_pixmap;
        m_actions = nm.m_actions;
        m_timeout = nm.m_timeout;
        m_noSave = nm.m_noSave;
        m_origin_actions = nm.m_origin_actions;
        m_origin_hints = nm.m_origin_hints;
        m_origin_icon = nm.m_origin_icon;
    }

    void setMessage(const QString& app_name,
                    uint replaces_id,
                    const QString& app_icon,
                    const QString& summary,
                    const QString& body,
                    const QStringList& actions,
                    const QVariantMap& hints,
                    int expire_timeout,
                    bool noSave);

private:
    QPixmap getPixmapFromHint(const QVariant &argument) const;
    QPixmap getPixmapFromString(const QString &str) const;

    QString m_origin_icon;
    QStringList m_origin_actions;
    QVariantMap m_origin_hints;
};

#endif // NOTIFYMESSAGE_H
