#ifndef NOTIFYPOPUP_H
#define NOTIFYPOPUP_H

#include <QWidget>
#include <QHBoxLayout>
#include <QLabel>
#include <QToolButton>
#include <QComboBox>
#include <Nde/Settings>
#include <QListWidget>
#include <QScrollArea>

#include "notifypopupitem.h"
#include "notifymessage.h"
#include "../panel/ndepanel.h"
#include "../panel/indepanelplugin.h"
#include <QListView>

class TimerComboBox :public QComboBox
{
    Q_OBJECT
public:
    explicit TimerComboBox(){this->setView(new QListView());}
    ~TimerComboBox() override{}

Q_SIGNALS:
    void actionShowPopup();
    void actionHidePopup();

private:
    void hidePopup() override;
    void showPopup() override;
};

class NotifyPopup : public QWidget
{
    Q_OBJECT

public:
    explicit NotifyPopup(INdePanelPlugin * plugin, QWidget *parent = nullptr);
    ~NotifyPopup();

    void setValues(NotifyMessage nm);

    void realign();
    int getTimeInterval(int);
    void startTimer();
    void NotificationClosed(uint);

Q_SIGNALS:
    void triggered();
    void actionTriggered(uint id, const QString &actionKey);
    void actionShowPopup();
    void actionHidePopup();

protected:
    bool event(QEvent *event) override;

private Q_SLOTS:
    void slotClose();
    void on_m_cbox_interval_indexChanged(int);
    void onSettingsChanged();
    void onClearItem();

private:
    void adjustPosition();
private:
    INdePanelPlugin * mPlugin;

    INdePanel::Position mCurPanelPos; //位置
    bool mCompositorOpen; //特效开关
    NotifyMessage m_notifyMsg;
    QWidget * mBackground; //实际背景
    bool m_isShow{ true };
    bool m_isCurrentPopup{ true };
    bool m_isComboxOpen{ false };
    QTimer * m_timerInterval;
    Nde::Settings * m_setting;
    int m_timeIndex{0};
    int m_height {0};
    int m_fixedHeight{0};
    //界面元素
    QVBoxLayout * m_vlayout;

    QToolButton * m_closeBtn;

    QVBoxLayout * m_scrollAreaLayout;
    QScrollArea * m_scrollArea;
    QWidget * m_scrollAreaWidget;
    QVBoxLayout * m_scrollAreaWidgetLayout;

    QVBoxLayout * m_comboxLayout;
    TimerComboBox * m_cbox_interval;
    QList<NotifyPopupItem*> m_notifyPopupItems;
};
#endif // NOTIFYPOPUP_H
