#ifndef NOTIFYPOPUPITEM_H
#define NOTIFYPOPUPITEM_H

#include <QWidget>
#include <QHBoxLayout>
#include <QLabel>
#include <QToolButton>

#include "notifymessage.h"

class NotifyPopupItem : public QWidget
{
    Q_OBJECT
public:
    explicit NotifyPopupItem(NotifyMessage msg, QWidget *parent = nullptr);
    ~NotifyPopupItem(){}
    NotifyMessage getNotifyMessage();

public Q_SLOTS:
    void slotActionBtnClicked();
    void slotClose();

protected:
    void paintEvent(QPaintEvent *event) override;
private:
    void setValues(NotifyMessage msg);

Q_SIGNALS:
    void triggered();
    void actionTriggered(uint id, const QString &actionKey);
    void actionClose();

private:
    NotifyMessage m_notifyMsg;

    QHBoxLayout * m_layout;
    QLabel * m_labelIcon;
    QVBoxLayout * m_layout_icon;
    QLabel * m_labelApplication;
    QLabel * m_labelSummary;
    QLabel * m_labelBody;
    QVBoxLayout * m_layout_text;
    QToolButton * m_btn_close;
    QVBoxLayout * m_layout_btn;

    QFrame * m_frame_actions;
    QList<QToolButton*> m_btn_actions;
    QGridLayout * m_layout_actions;
};

#endif // NOTIFYPOPUPITEM_H
