/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)LGPL2+
 *
 * Nde - a lightweight, Qt based, desktop toolset
 * https://lxqt.org
 *
 * Copyright: 2010-2011 Razor team
 * Authors:
 *   Petr Vanek <petr@scribus.info>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef SHOWDESKTOP_H
#define SHOWDESKTOP_H

#include "../panel/indepanelplugin.h"
#include <QToolButton>
#include "../plugin-taskbar/ndetaskbar.h"
#include "showdesktopwidget.h"


namespace GlobalKeyShortcut
{
class Action;
}

class ShowDesktop :  public QObject, public INdePanelPlugin
{
    Q_OBJECT

public:
    ShowDesktop(const INdePanelPluginStartupInfo &startupInfo);
    void realign();

    virtual QWidget *widget() { return mButton; }
    virtual QString themeId() const { return "ShowDesktop"; }

private:
    GlobalKeyShortcut::Action * m_key;
    GlobalKeyShortcut::Action * m_show_desktop;
    GlobalKeyShortcut::Action * m_minimize_win;
    int mTaskBarWidth;
    QMap<WId,bool> windowFlagList;

    bool isWindowHighlightable(WId window);

private Q_SLOTS:
    void toggleShowingDesktop();
    void shortcutRegistered();
    void minimizeAllWindows();
    void showHideAction();

private:
    ShowDesktopWidget *mButton;

protected:
    void relayout();

};

class ShowDesktopLibrary: public QObject, public INdePanelPluginLibrary
{
    Q_OBJECT
    // Q_PLUGIN_METADATA(IID "lxqt.org/Panel/PluginInterface/3.0")
    Q_INTERFACES(INdePanelPluginLibrary)
public:
    INdePanelPlugin *instance(const INdePanelPluginStartupInfo &startupInfo) const
    {
        return new ShowDesktop(startupInfo);
    }
};


#endif
