#ifndef SHOWDESKTOPWIDGET_H
#define SHOWDESKTOPWIDGET_H

#include <QWidget>
#include <QToolButton>
#include "../panel/indepanelplugin.h"
#include <KWindowSystem/KWindowSystem>
#include <KWindowSystem/NETWM>
#include <QX11Info>
#include <QMap>
#include <QStack>

#define LEFT_WIN_KEY_ENCODE  133

class QSignalMapper;
namespace GlobalKeyShortcut
{
class Action;
}

class ShowDesktopWidget : public QToolButton
{
    Q_OBJECT
public:
    explicit ShowDesktopWidget(QWidget *parent = nullptr);

private:
    void invokeShortcut(const QString &shortcut);
    QSignalMapper *mSignalMapperTileWindow;
    QList<GlobalKeyShortcut::Action*> mKeys;

enum {
    SC_TYPE_TOP = 1,
    SC_TYPE_BOTTOM,
    SC_TYPE_LEFT,
    SC_TYPE_RIGHT
};

private Q_SLOTS:
    void registerShortcuts();
    void shortcutRegistered();
    void activateTask(int pos);
};

#endif // SHOWDESKTOPWIDGET_H
