/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)LGPL2+
 *
 * Nde - a lightweight, Qt based, desktop toolset
 * https://lxqt.org
 *
 * Copyright: 2011 Razor team
 *            2014 Nde team
 * Authors:
 *   Alexander Sokoloff <sokoloff.a@gmail.com>
 *   Maciej Płaza <plaza.maciej@gmail.com>
 *   Kuzma Shapran <kuzma.shapran@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */

#ifndef NDETASKPOPUP_H
#define NDETASKPOPUP_H

#include <QHash>
#include <QFrame>
#include <QLayout>
#include <QTimer>
#include <QEvent>
#include <Nde/GridLayout>
#include "ndetaskbutton.h"
#include "ndetaskgroup.h"
#include "ndetaskbar.h"
#include "ndethumbnailbutton.h"

class NdeGroupPopup: public QFrame
{
    Q_OBJECT

public:
    NdeGroupPopup(NdeTaskGroup *group);
    ~NdeGroupPopup();

    void realign();

    void hide(bool fast = false);
    void show();

    // Layout
    int indexOf(NdeThumbnailButton *button) { return layout()->indexOf(button); }
    int count() { return layout()->count(); }
    QLayoutItem * itemAt(int i) { return layout()->itemAt(i); }
    int spacing() { return layout()->spacing(); }
    void addButton(NdeThumbnailButton * button) { layout()->addWidget(button);changeLayout(); }
    void removeWidget(QWidget *button) { layout()->removeWidget(button); changeLayout();}
    void changeLayout();
protected:
    void dragEnterEvent(QDragEnterEvent * event);
    void dragLeaveEvent(QDragLeaveEvent *event);
    void dropEvent(QDropEvent * event);
    void leaveEvent(QEvent * event);
    void enterEvent(QEvent * event);
    void paintEvent(QPaintEvent * event);

    void closeTimerSlot();

private:
    NdeTaskGroup *mGroup;
    QTimer mCloseTimer;
    Nde::GridLayout * mLayout;

    bool mCompositorOpen; //特效开关
};

#endif // NDETASKPOPUP_H
