/* BEGIN_COMMON_COPYRIGHT_HEADER
 * (c)LGPL2+
 *
 * Nde - a lightweight, Qt based, desktop toolset
 * https://lxqt.org
 *
 * Copyright: 2012 Razor team
 * Authors:
 *   Alexander Sokoloff <sokoloff.a@gmail.com>
 *
 * This program or library is free software; you can redistribute it
 * and/or modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 *
 * END_COMMON_COPYRIGHT_HEADER */


#ifndef NDETASKBARPLUGIN_H
#define NDETASKBARPLUGIN_H

#include "../panel/indepanel.h"
#include "../panel/indepanelplugin.h"
#include "ndetaskbar.h"
#include <QDebug>
class NdeTaskBar;

class NdeTaskBarPlugin : public QObject, public INdePanelPlugin
{
    Q_OBJECT
public:
    NdeTaskBarPlugin(const INdePanelPluginStartupInfo &startupInfo);
    ~NdeTaskBarPlugin();

    QString themeId() const { return "TaskBar"; }
    virtual Flags flags() const { return HaveConfigDialog | NeedsHandle |SingleInstance; }

    QWidget *widget() { return mTaskBar; }
    QDialog *configureDialog();

    void settingsChanged() { mTaskBar->settingsChanged(); }
    void realign();

    bool isSeparate() const { return true; }
    bool isExpandable() const { return true; }

    bool isIconMode() const;
    void setIconMode(bool isIconMode = true);
    void panelSizeChanged(){mTaskBar->panelSizeChanged();}
private:
    NdeTaskBar *mTaskBar;
};

class NdeTaskBarPluginLibrary: public QObject, public INdePanelPluginLibrary
{
    Q_OBJECT
    // Q_PLUGIN_METADATA(IID "lxqt.org/Panel/PluginInterface/3.0")
    Q_INTERFACES(INdePanelPluginLibrary)
public:
    INdePanelPlugin *instance(const INdePanelPluginStartupInfo &startupInfo) const { return new NdeTaskBarPlugin(startupInfo);}
};

#endif // NDETASKBARPLUGIN_H
