#ifndef NDETHUMBNAILBUTTON_H
#define NDETHUMBNAILBUTTON_H

#include <QTimer>
#include "../panel/indepanel.h"
#include <QFrame>
#include <QToolButton>
#include <QtQuickWidgets/QQuickWidget>

class QLabel;
class NdeTaskBar;

class NdeThumbnailButton : public QFrame
{
    Q_OBJECT
public:
    explicit NdeThumbnailButton(const WId window, NdeTaskBar * taskBar, QWidget *parent = nullptr);
    virtual ~NdeThumbnailButton() override;

    void updateTitle();
    QString title() const;
    bool isApplicationActive() const;
    bool isOnDesktop(int desktop) const;
    bool hasUrgencyHint() const { return mUrgencyHint; }
    void setUrgencyHint(bool set);
    WId windowId() const { return mWindow; }
    bool isOnCurrentScreen() const;
    NdeTaskBar * parentTaskBar() const {return mParentTaskBar;}
    void addThumbnail(void* pixmap);
    virtual void setAutoRotation(bool value, INdePanel::Position position);

    bool onWindowDamaged(const uint8_t responseType);
    void paintEvent(QPaintEvent *);
    void setBordeState(bool state){bordeState=state;}
Q_SIGNALS:
    void clicked();
public Q_SLOTS:
    void closeApplication();
    void raiseApplication();
    void minimizeApplication();

    void setOrigin(Qt::Corner);

protected:
    void enterEvent(QEvent * event) override;
    virtual void leaveEvent(QEvent * event) override;
    void mousePressEvent(QMouseEvent *event) override;
    void mouseReleaseEvent(QMouseEvent *event) override;
    virtual bool event(QEvent *e) override;
private:
    WId mWindow;
    NdeTaskBar * mParentTaskBar;
    QToolButton *closeButton;
    QLabel *windowTitle;
//    QLabel *thumbnailPixmap;
    bool mUrgencyHint;
    Qt::Corner mOrigin;

    QQuickWidget* m_thumbnailWidget;
    void* m_image;
    bool bordeState;
};

typedef QHash<WId,NdeThumbnailButton*> NdeThumbnailButtonHash;
#endif
