#ifndef DATEWIDGET_H
#define DATEWIDGET_H

#include <QWidget>
#include <QLabel>

namespace Ui {
class dateWidget;
}

class Date : public QObject
{
    Q_OBJECT
public:
    explicit Date(QObject *parent = 0);
public:
    static QString getLunarDate(int year, int month, int day);
};

class DateConfig: public QObject
{
    Q_OBJECT
public:
    static DateConfig& instance();
    int getDate(QDate date);
private:
    DateConfig() {
        Init();
    }
    void Init();
private:
    QHash<QString,int> worklist;
};

class dateWidget : public QWidget
{
    Q_OBJECT

public:
    explicit dateWidget(QWidget *parent = nullptr);
    ~dateWidget();

    void setDateText(QDate date);
    void refreshSize(bool normal);

protected:
    virtual void paintEvent(QPaintEvent *event);
    virtual void mousePressEvent(QMouseEvent *event);
    virtual void enterEvent(QEvent *event);
    virtual void leaveEvent(QEvent *event);

private:
    Ui::dateWidget *ui;
    QLabel *labelAdd;
};

#endif // DATEWIDGET_H
